---
title: Get roles
slug: opti-id/api/get-roles
docTags: 
createdAt: 2026-10-01T19:58:50.958Z
---

{
  "id": "sBu6tqX_nDGtrkVXY07NR",
  "type": "api-oas-v2",
  "data": {
    "method": "GET",
    "url": "https://usermgmt-api.optimizely.com/api/roles",
    "servers": [
      {
        "url": "https://usermgmt-api.optimizely.com/api/roles"
      }
    ],
    "name": "Get roles",
    "description": "Get a page of roles.",
    "contentType": "application/json",
    "request": {
      "pathParameters": [],
      "headerParameters": [
        {
          "name": "accept",
          "type": "string",
          "kind": "optional",
          "description": "Generated from available response content types",
          "enum": [
            "application/json"
          ],
          "default": "application/json"
        }
      ],
      "queryParameters": [
        {
          "kind": "optional",
          "name": "name",
          "type": "string",
          "description": "Name of the role."
        },
        {
          "kind": "optional",
          "name": "description",
          "type": "string",
          "description": "Description of the role."
        },
        {
          "kind": "optional",
          "name": "productId",
          "type": "string",
          "description": "Product ID of the role."
        },
        {
          "kind": "optional",
          "name": "experimentalOrganizationId",
          "type": "string",
          "description": "Organization ID assigned to the experimental roles."
        },
        {
          "kind": "optional",
          "name": "roleType",
          "type": "string",
          "description": "<p>Type of role. Possible values: 0 for Product Defined, 1 for Customer Defined for Product, 2 for Customer Defined for Product Instance.</p>"
        },
        {
          "kind": "optional",
          "name": "ownedBy",
          "type": "string",
          "description": "Owner of the role."
        },
        {
          "kind": "optional",
          "name": "targetIds",
          "type": "array",
          "description": "<p>IDs of the targets associated with the role, like the IDs of products or instances.</p>",
          "schema": [],
          "itemType": "string",
          "customType": "string[]"
        },
        {
          "kind": "optional",
          "name": "isActive",
          "type": "boolean",
          "description": "<p>True or false, indicating whether the role is active.</p>"
        },
        {
          "kind": "optional",
          "name": "properties",
          "type": "array",
          "description": "Properties defined in the role.",
          "schema": [
            {
              "name": "name",
              "kind": "optional",
              "type": "string",
              "description": ""
            },
            {
              "name": "value",
              "kind": "optional",
              "type": "string",
              "description": ""
            }
          ],
          "itemType": "object",
          "customType": "object[]"
        },
        {
          "kind": "optional",
          "name": "attributeId",
          "type": "string",
          "description": ""
        },
        {
          "kind": "optional",
          "name": "excludeTeams",
          "type": "boolean",
          "description": "<p>True or false, indicating whether to exclude Teams roles from the results. Defaults to true.</p>"
        },
        {
          "kind": "optional",
          "name": "size",
          "type": "integer<int32>",
          "description": "Number of results to include per page.",
          "format": "int32"
        },
        {
          "kind": "optional",
          "name": "offset",
          "type": "integer<int32>",
          "description": "Offset paging of results.",
          "format": "int32"
        }
      ],
      "bodyDataParameters": [],
      "formDataParameters": [],
      "oAuthParameters": [
        {
          "id": "oidc_auth",
          "name": "oidc_auth",
          "kind": "optional",
          "type": "oauth2",
          "oauth2Flows": {
            "authorizationCode": {
              "authorizationUrl": "https://login.optimizely.com/oauth2/default/v1/authorize",
              "tokenUrl": "https://login.optimizely.com/oauth2/default/v1/token",
              "scopes": {
                "openid": "Identifies the request as an OpenID Connect request (required)",
                "profile": "Requests access to the end user's default profile claims",
                "email": "Requests access to the email and email_verified claims",
                "offline_access": "Requests a refresh token used to obtain more access tokens without re-prompting the user for authentication",
                "idx_instancepermissions": "Request Instance Permissions claim for use with Optimizely Products"
              }
            }
          },
          "requiredScopes": [
            "openid",
            "profile",
            "email",
            "offline_access",
            "idx_instancepermissions"
          ]
        }
      ],
      "cookieParameters": []
    },
    "responses": [
      {
        "statusCode": "200",
        "description": "The roles response.",
        "jsonExample": "",
        "isExpanded": true,
        "schema": [
          {
            "kind": "optional",
            "type": "object",
            "description": "",
            "customType": "page_role",
            "schema": [
              {
                "name": "totalItemCount",
                "kind": "optional",
                "type": "integer<int32>",
                "nullable": true,
                "description": "",
                "format": "int32"
              },
              {
                "name": "items",
                "kind": "optional",
                "type": "array",
                "nullable": true,
                "description": "",
                "modelRef": "#/components/schemas/role",
                "customType": "role[]",
                "schema": [
                  {
                    "name": "id",
                    "kind": "optional",
                    "type": "string",
                    "description": ""
                  },
                  {
                    "name": "name",
                    "kind": "optional",
                    "type": "string",
                    "description": ""
                  },
                  {
                    "name": "description",
                    "kind": "optional",
                    "type": "string",
                    "description": ""
                  },
                  {
                    "name": "productId",
                    "kind": "optional",
                    "type": "string",
                    "description": ""
                  },
                  {
                    "name": "roleType",
                    "kind": "optional",
                    "type": "integer<int32>",
                    "description": "",
                    "default": 0,
                    "format": "int32",
                    "enum": [
                      "0",
                      "1",
                      "2"
                    ]
                  },
                  {
                    "name": "ownedBy",
                    "kind": "optional",
                    "type": "string",
                    "description": ""
                  },
                  {
                    "name": "targetIds",
                    "kind": "optional",
                    "type": "array",
                    "description": "",
                    "example": "",
                    "itemType": "string",
                    "customType": "string[]",
                    "itemExample": "",
                    "itemDefault": ""
                  },
                  {
                    "name": "isActive",
                    "kind": "optional",
                    "type": "boolean",
                    "description": ""
                  },
                  {
                    "name": "attributes",
                    "kind": "optional",
                    "type": "array",
                    "description": "",
                    "modelRef": "#/components/schemas/attribute",
                    "customType": "attribute[]",
                    "schema": [
                      {
                        "name": "id",
                        "kind": "optional",
                        "type": "string",
                        "description": ""
                      },
                      {
                        "name": "key",
                        "kind": "optional",
                        "type": "string",
                        "description": ""
                      },
                      {
                        "name": "values",
                        "kind": "optional",
                        "type": "array",
                        "description": "",
                        "example": "",
                        "itemType": "string",
                        "customType": "string[]",
                        "itemExample": "",
                        "itemDefault": ""
                      },
                      {
                        "name": "instanceId",
                        "kind": "optional",
                        "type": "string",
                        "description": ""
                      },
                      {
                        "name": "type",
                        "kind": "optional",
                        "type": "string",
                        "description": ""
                      },
                      {
                        "name": "name",
                        "kind": "optional",
                        "type": "string",
                        "description": ""
                      },
                      {
                        "name": "description",
                        "kind": "optional",
                        "type": "string",
                        "description": ""
                      },
                      {
                        "name": "productId",
                        "kind": "optional",
                        "type": "string",
                        "description": ""
                      },
                      {
                        "name": "isActive",
                        "kind": "optional",
                        "type": "boolean",
                        "description": ""
                      },
                      {
                        "name": "created",
                        "kind": "optional",
                        "type": "string<date-time>",
                        "description": "",
                        "format": "date-time"
                      },
                      {
                        "name": "modified",
                        "kind": "optional",
                        "type": "string<date-time>",
                        "description": "",
                        "format": "date-time"
                      },
                      {
                        "name": "links",
                        "kind": "optional",
                        "type": "array",
                        "nullable": true,
                        "description": "",
                        "modelRef": "#/components/schemas/link",
                        "customType": "link[]",
                        "schema": [
                          {
                            "name": "rel",
                            "kind": "optional",
                            "type": "string",
                            "nullable": true,
                            "description": ""
                          },
                          {
                            "name": "href",
                            "kind": "optional",
                            "type": "string",
                            "nullable": true,
                            "description": ""
                          }
                        ]
                      }
                    ]
                  },
                  {
                    "name": "properties",
                    "kind": "optional",
                    "type": "array",
                    "description": "",
                    "modelRef": "#/components/schemas/property",
                    "customType": "property[]",
                    "schema": [
                      {
                        "name": "name",
                        "kind": "optional",
                        "type": "string",
                        "nullable": true,
                        "description": ""
                      },
                      {
                        "name": "value",
                        "kind": "optional",
                        "type": "string",
                        "nullable": true,
                        "description": ""
                      }
                    ]
                  },
                  {
                    "name": "created",
                    "kind": "optional",
                    "type": "string<date-time>",
                    "description": "",
                    "format": "date-time"
                  },
                  {
                    "name": "modified",
                    "kind": "optional",
                    "type": "string<date-time>",
                    "description": "",
                    "format": "date-time"
                  },
                  {
                    "name": "links",
                    "kind": "optional",
                    "type": "array",
                    "nullable": true,
                    "description": "",
                    "modelRef": "#/components/schemas/link",
                    "customType": "link[]",
                    "schema": [
                      {
                        "name": "rel",
                        "kind": "optional",
                        "type": "string",
                        "nullable": true,
                        "description": ""
                      },
                      {
                        "name": "href",
                        "kind": "optional",
                        "type": "string",
                        "nullable": true,
                        "description": ""
                      }
                    ]
                  }
                ]
              },
              {
                "name": "links",
                "kind": "optional",
                "type": "array",
                "nullable": true,
                "description": "",
                "modelRef": "#/components/schemas/link",
                "customType": "link[]",
                "schema": [
                  {
                    "name": "rel",
                    "kind": "optional",
                    "type": "string",
                    "nullable": true,
                    "description": ""
                  },
                  {
                    "name": "href",
                    "kind": "optional",
                    "type": "string",
                    "nullable": true,
                    "description": ""
                  }
                ]
              }
            ],
            "modelRef": "#/components/schemas/page_role",
            "isExpanded": true
          }
        ]
      },
      {
        "statusCode": "400",
        "description": "The request was invalid or cannot be otherwise served. An accompanying error message will explain further.",
        "jsonExample": "",
        "isExpanded": true,
        "schema": [
          {
            "kind": "optional",
            "type": "array",
            "description": "",
            "customType": "validationError[]",
            "schema": [
              {
                "name": "field",
                "kind": "optional",
                "type": "string",
                "nullable": true,
                "description": ""
              },
              {
                "name": "code",
                "kind": "optional",
                "type": "string",
                "nullable": true,
                "description": ""
              },
              {
                "name": "message",
                "kind": "optional",
                "type": "string",
                "nullable": true,
                "description": ""
              }
            ],
            "modelRef": "#/components/schemas/validationError",
            "isExpanded": true
          }
        ]
      },
      {
        "statusCode": "401",
        "description": "Unauthorized access to endpoint.",
        "jsonExample": "",
        "isExpanded": true
      },
      {
        "statusCode": "403",
        "description": "Forbidden access to endpoint.",
        "jsonExample": "",
        "isExpanded": true
      },
      {
        "statusCode": "500",
        "description": "<p>A server error occurred, please try again.</p>",
        "jsonExample": "",
        "isExpanded": true
      }
    ],
    "hasXCodeSamples": false,
    "examples": {
      "languages": [
        {
          "id": "QtS4fq12IZ88NPFmBsp_3",
          "language": "curl",
          "label": "cURL",
          "code": "curl --request GET \\\n     --url 'https://usermgmt-api.optimizely.com/api/roles?properties=array' \\\n     --header 'accept: application/json'"
        },
        {
          "id": "ZV4eOMWlVQKRz6Wn0GqOz",
          "language": "javascript",
          "label": "javascript",
          "code": "var myHeaders = new Headers();\nmyHeaders.append(\"accept\", \"application/json\");\nmyHeaders.append(\"content-type\", \"application/json\");\n\nvar requestOptions = {\n   method: 'GET',\n   headers: myHeaders,\n   redirect: 'follow'\n};\n\nfetch(\"https://usermgmt-api.optimizely.com/api/roles?properties=array\", requestOptions)\n   .then(response => response.text())\n   .then(result => console.log(result))\n   .catch(error => console.log('error', error));"
        },
        {
          "id": "D8z4FQxVQQN4so62sHQqf",
          "language": "ruby",
          "label": "Ruby",
          "code": "require \"uri\"\nrequire \"json\"\nrequire \"net/http\"\n\nurl = URI(\"https://usermgmt-api.optimizely.com/api/roles?properties=array\")\n\nhttps = Net::HTTP.new(url.host, url.port)\nhttps.use_ssl = true\n\nrequest = Net::HTTP::Get.new(url)\nrequest[\"accept\"] = \"application/json\"\nrequest[\"content-type\"] = \"application/json\"\n\nresponse = https.request(request)\nputs response.read_body\n"
        },
        {
          "id": "PfChXBXYv8Nv6PQ2_9ISv",
          "language": "python",
          "label": "Python",
          "code": "import requests\nimport json\n\nurl = \"https://usermgmt-api.optimizely.com/api/roles?properties=array\"\n\npayload = {}\nheaders = {\n   'accept': 'application/json',\n   'content-type': 'application/json'\n}\n\nresponse = requests.request(\"GET\", url, headers=headers, data=payload)\n\nprint(response.text)\n"
        }
      ],
      "selectedLanguageId": "QtS4fq12IZ88NPFmBsp_3"
    },
    "results": {
      "languages": [
        {
          "id": "response-0-200",
          "language": "200",
          "code": "// The roles response.\n{\n  \"totalItemCount\": \"\",\n  \"items\": [\n    {\n      \"id\": \"\",\n      \"name\": \"\",\n      \"description\": \"\",\n      \"productId\": \"\",\n      \"roleType\": \"\",\n      \"ownedBy\": \"\",\n      \"targetIds\": [\n        \"\"\n      ],\n      \"isActive\": false,\n      \"attributes\": [\n        {\n          \"id\": \"\",\n          \"key\": \"\",\n          \"values\": [\n            \"\"\n          ],\n          \"instanceId\": \"\",\n          \"type\": \"\",\n          \"name\": \"\",\n          \"description\": \"\",\n          \"productId\": \"\",\n          \"isActive\": false,\n          \"created\": \"\",\n          \"modified\": \"\",\n          \"links\": [\n            {\n              \"rel\": \"\",\n              \"href\": \"\"\n            }\n          ]\n        }\n      ],\n      \"properties\": [\n        {\n          \"name\": \"\",\n          \"value\": \"\"\n        }\n      ],\n      \"created\": \"\",\n      \"modified\": \"\",\n      \"links\": [\n        {\n          \"rel\": \"\",\n          \"href\": \"\"\n        }\n      ]\n    }\n  ],\n  \"links\": [\n    {\n      \"rel\": \"\",\n      \"href\": \"\"\n    }\n  ]\n}"
        },
        {
          "id": "response-1-400",
          "language": "400",
          "code": "// The request was invalid or cannot be otherwise served. An accompanying error message will explain further.\n[\n  {\n    \"field\": \"\",\n    \"code\": \"\",\n    \"message\": \"\"\n  }\n]"
        },
        {
          "id": "response-2-401",
          "language": "401",
          "code": "// Unauthorized access to endpoint.\n"
        },
        {
          "id": "response-3-403",
          "language": "403",
          "code": "// Forbidden access to endpoint.\n"
        },
        {
          "id": "response-4-500",
          "language": "500",
          "code": "// A server error occurred, please try again.\n"
        }
      ],
      "selectedLanguageId": "response-0-200"
    }
  },
  "children": [
    {
      "text": ""
    }
  ]
}